package com.ARview;

import java.io.DataInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.hardware.Camera;
import android.hardware.Camera.AutoFocusCallback;
import android.hardware.Camera.Parameters;
import android.hardware.Camera.Size;
import android.os.Bundle;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

public class ARview extends Activity {
    camera_view cam;
    frame_view test_bit;
    TextView text;//word_info
	db_serch dbs;//word_info
    //////////////////////////////////////////////////////////
    TextView tv;
    rect_view rec;
    View.OnTouchListener moving;
    char_scaner cs;
    int touch_x, moving_x;
    boolean moving_go_right,moving_go_left;
    Button moving_button;
    ListView find_list;
     //////////////////////////////////////////////////////////
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        text = (TextView)findViewById(R.id.word_info);//word_info
    	dbs = new db_serch();//word_info
        cs = new char_scaner();
        cam = (camera_view)findViewById(R.id.preview);
        test_bit = (frame_view)findViewById(R.id.chk_view);
        moving_button = (Button)findViewById(R.id.Button01);
        moving_button.setBackgroundColor(Color.TRANSPARENT);
        tv = (TextView)findViewById(R.id.TextView01);
        tv.setText("");
        cs.set_text(tv);
        test_bit.set_cs(cs);
        dbs.set_context(this, text);//word_info
        test_bit.set_dbs(dbs);
        find_list= (ListView)findViewById(R.id.ListView01);
        ////////////////////////////////////////////////////////// //ract
        moving = new View.OnTouchListener() {
			public boolean onTouch(View v, MotionEvent event) {
				// TODO Auto-generated method stub
				switch(event.getAction()){
				case MotionEvent.ACTION_DOWN://thouch start
					touch_x = (int)event.getX();
					Log.e("move move","1 : "+touch_x+" 2 : "+moving_x);
					if(touch_x<rec.right+50&&touch_x>rec.right-50&&rec.top<=event.getY()&&rec.bottom>=event.getY()){
						moving_go_right=true;
					}
					else if(touch_x<rec.left+50&&touch_x>rec.left-50&&rec.top<=event.getY()&&rec.bottom>=event.getY()){
						moving_go_left=true;
					}
					break;
				case MotionEvent.ACTION_MOVE://thouch move
					moving_x = (int)event.getX();
					Log.e("move move","1 : "+touch_x+" 2 : "+moving_x);
					if(moving_go_right){
						if(touch_x>moving_x){
							if(rec.change-5>-30)rec.change=rec.change-5;
						}
						else{
							if(rec.change+5<100)rec.change=rec.change+5;
						}
						rec.run();
					}
					else if(moving_go_left){
						if(touch_x<moving_x){
							if(rec.change-5>-30)rec.change=rec.change-5;
						}
						else{
							if(rec.change+5<100)rec.change=rec.change+5;
						}
						rec.run();						
					}
					break;
				case MotionEvent.ACTION_UP://thouch finish
					moving_go_right = false;
					moving_go_left=false;
					break;
			}
				return false;
			}
		};
		moving_button.setOnTouchListener(ARview.this.moving);
		moving_button.setBackgroundResource(R.drawable.outline);
        moving_go_right=false;
        rec = (rect_view)findViewById(R.id.rect);
        rec.setOnTouchListener(ARview.this.moving);
        //////////////////////////////////////////////////////////
        test_bit.setrect_view(rec);
        cam.set_freame_view(test_bit);
        findViewById(R.id.word).setBackgroundResource(R.drawable.voca);
        findViewById(R.id.focus).setBackgroundResource(R.drawable.view_selected);
        
        findViewById(R.id.focus).setOnClickListener(new Button.OnClickListener() {
			public void onClick(View v) {
				//shut.setEnabled(false);
				//cam.cam.autoFocus(mAutoFocus);
				cam.set();
			}
		});
    }
	AutoFocusCallback mAutoFocus = new AutoFocusCallback() {
		public void onAutoFocus(boolean success, Camera camera) {
			//shut.setEnabled(success);
		}
	};
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
class camera_view extends SurfaceView implements SurfaceHolder.Callback{
	SurfaceHolder cam_holder;
	Camera cam;
	frame_view test_view;
	int count = 0;
	public camera_view(Context context, AttributeSet attrs) {
		super(context, attrs);
		cam_holder = getHolder();
		cam_holder.addCallback(this);
		cam_holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);	
	}
	public void set(){
		Parameters params = cam.getParameters();
		params.setFocusMode(Camera.Parameters.FOCUS_MODE_MACRO);
		cam.setParameters(params);
	}
	public void set_freame_view(frame_view frame_view){
		this.test_view = frame_view;
	}
	public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
		// TODO Auto-generated method stub
		Camera.Parameters params = cam.getParameters();
        List<Size> arSize = params.getSupportedPreviewSizes();
        if (arSize == null) {
			params.setPreviewSize(width, height);
        } else {
	        int diff = 10000;
	        Size opti = null;
	        for (Size s : arSize) {
	        	if (Math.abs(s.height - height) < diff) {
	        		diff = Math.abs(s.height - height);
	        		opti = s;	        		
	        	}
	        }
			params.setPreviewSize(opti.width, opti.height);
        }
		cam.setParameters(params);			
		cam.setPreviewCallback(preview);
		cam.startPreview();		
	}
	public void surfaceCreated(SurfaceHolder holder) {
		// TODO Auto-generated method stub	
		cam = Camera.open();
		try {
			cam.setPreviewDisplay(holder);
		} catch (IOException e) {
			cam.release();
			cam = null;
		}
	}
	public void surfaceDestroyed(SurfaceHolder holder) {
		// TODO Auto-generated method stub
		if (cam != null) {
			cam.stopPreview();
			cam.release();
			cam = null;
		}		
	}
	Camera.PreviewCallback preview = new Camera.PreviewCallback() {
		public void onPreviewFrame(byte[] data, Camera camera) {
			// TODO Auto-generated method stub	
			count++;	
			if(count == 3){
				count = 0;
				test_view.setData(data);
				test_view.run();
			}
		}
	};
}
///////////////////////////////////////////////////////////////////////////////////////////////////////
class rect_view extends View implements Runnable{	//ract
	Path pat;
	Paint p;
	static int left,top,right,bottom,change;
	int touch_x,moving_x;
	boolean moving_go_right;
	
	public rect_view(Context context, AttributeSet attrs) {
		super(context, attrs);
		// TODO Auto-generated constructor stub		
		p = new Paint();
		p.setStrokeWidth(5);
		p.setColor(Color.GREEN);
		p.setStyle(Paint.Style.STROKE);
		change=0;
		moving_go_right=false;
	}
	@Override
	protected void onDraw(Canvas canvas) {
		// TODO Auto-generated method stub
		super.onDraw(canvas);
		left = this.getWidth()/2-60-change;
		top = this.getHeight()/2-25;
		right = this.getWidth()/2+60+change;
		bottom = top+50;
		canvas.drawColor(Color.TRANSPARENT);
		pat =new Path();
		Log.e("testtest", "L : "+left+"  R : "+right);
		pat.addRect(left,top,right,bottom , Path.Direction.CW);
		canvas.drawPath(pat, p);		
	}
	public void run() {
		invalidate();		
	}	
}